Main Page Modules Class Hierarchy Data Structures File List Data Fields Globals Related Pages

# Oscl_Rb_Tree< Key, Value, KeyOfValue, Compare, Alloc > Class Template Reference
[OSCL Base]

`#include <oscl_tree.h>`

Inheritance diagram for Oscl_Rb_Tree< Key, Value, KeyOfValue, Compare, Alloc >:

## Public Types
typedef Key | key_type
typedef Value | value_type
typedef value_type * | pointer
typedef const value_type * | const_pointer
typedef value_type & | reference
typedef const value_type & | const_reference
typedef Oscl_Rb_Tree_Node< Value >::link_type | link_type
typedef Oscl_Rb_Tree_Iterator< value_type > | iterator
typedef Oscl_Rb_Tree_Const_Iterator< value_type > | const_iterator
typedef uint32 | size_type
typedef int32 | difference_type
## Public Methods
| Oscl_Rb_Tree (const Compare &comp=Compare())
| Oscl_Rb_Tree (const Oscl_Rb_Tree< Key, Value, KeyOfValue, Compare, Alloc > &x)
| ~Oscl_Rb_Tree ()
Oscl_Rb_Tree< Key, Value, KeyOfValue, Compare, Alloc > & | operator= (const Oscl_Rb_Tree< Key, Value, KeyOfValue, Compare, Alloc > &x)
iterator | begin ()
const_iterator | begin () const
iterator | end ()
const_iterator | end () const
bool | empty () const
size_type | size () const
size_type | max_size () const
Oscl_Pair< iterator, bool > | insert_unique (const value_type &v)
iterator | insert_unique (iterator position, const value_type &v)
void | insert_unique (const_iterator first, const_iterator last)
void | insert_unique (const value_type *first, const value_type *last)
void | erase (iterator position)
size_type | erase (const key_type &x)
void | erase (iterator first, iterator last)
void | erase (const key_type *first, const key_type *last)
void | clear ()
iterator | find (const Key &k)
const_iterator | find (const Key &k) const
size_type | count (const Key &k) const
iterator | lower_bound (const Key &k)
const_iterator | lower_bound (const Key &k) const
iterator | upper_bound (const Key &k)
const_iterator | upper_bound (const Key &k) const
Oscl_Pair< iterator, iterator > | equal_range (const Key &k)
Oscl_Pair< const_iterator, const_iterator > | equal_range (const Key &k) const

### template<class Key, class Value, class KeyOfValue, class Compare, class Alloc>
class Oscl_Rb_Tree< Key, Value, KeyOfValue, Compare, Alloc >

## Member Typedef Documentation

template<class Key, class Value, class KeyOfValue, class Compare, class Alloc>
typedef Oscl_Rb_Tree_Const_Iterator<value_type> Oscl_Rb_Tree< Key, Value, KeyOfValue, Compare, Alloc >::const_iterator

template<class Key, class Value, class KeyOfValue, class Compare, class Alloc>
typedef const value_type* Oscl_Rb_Tree< Key, Value, KeyOfValue, Compare, Alloc >::const_pointer

template<class Key, class Value, class KeyOfValue, class Compare, class Alloc>
typedef const value_type& Oscl_Rb_Tree< Key, Value, KeyOfValue, Compare, Alloc >::const_reference

template<class Key, class Value, class KeyOfValue, class Compare, class Alloc>
typedef int32 Oscl_Rb_Tree< Key, Value, KeyOfValue, Compare, Alloc >::difference_type

template<class Key, class Value, class KeyOfValue, class Compare, class Alloc>
typedef Oscl_Rb_Tree_Iterator<value_type> Oscl_Rb_Tree< Key, Value, KeyOfValue, Compare, Alloc >::iterator

template<class Key, class Value, class KeyOfValue, class Compare, class Alloc>
typedef Key Oscl_Rb_Tree< Key, Value, KeyOfValue, Compare, Alloc >::key_type

template<class Key, class Value, class KeyOfValue, class Compare, class Alloc>
typedef Oscl_Rb_Tree_Node<Value>::link_type Oscl_Rb_Tree< Key, Value, KeyOfValue, Compare, Alloc >::link_type

template<class Key, class Value, class KeyOfValue, class Compare, class Alloc>
typedef value_type* Oscl_Rb_Tree< Key, Value, KeyOfValue, Compare, Alloc >::pointer

template<class Key, class Value, class KeyOfValue, class Compare, class Alloc>
typedef value_type& Oscl_Rb_Tree< Key, Value, KeyOfValue, Compare, Alloc >::reference

template<class Key, class Value, class KeyOfValue, class Compare, class Alloc>
typedef uint32 Oscl_Rb_Tree< Key, Value, KeyOfValue, Compare, Alloc >::size_type

template<class Key, class Value, class KeyOfValue, class Compare, class Alloc>
typedef Value Oscl_Rb_Tree< Key, Value, KeyOfValue, Compare, Alloc >::value_type

## Constructor & Destructor Documentation

template<class Key, class Value, class KeyOfValue, class Compare, class Alloc>
Oscl_Rb_Tree< Key, Value, KeyOfValue, Compare, Alloc >::Oscl_Rb_Tree | ( | const Compare & | comp = Compare() | ) | `[inline]`

template<class Key, class Value, class KeyOfValue, class Compare, class Alloc>
Oscl_Rb_Tree< Key, Value, KeyOfValue, Compare, Alloc >::Oscl_Rb_Tree | ( | const Oscl_Rb_Tree< Key, Value, KeyOfValue, Compare, Alloc > & | x | ) | `[inline]`

template<class Key, class Value, class KeyOfValue, class Compare, class Alloc>
Oscl_Rb_Tree< Key, Value, KeyOfValue, Compare, Alloc >::~Oscl_Rb_Tree | ( |  | ) | `[inline]`

## Member Function Documentation

template<class Key, class Value, class KeyOfValue, class Compare, class Alloc>
const_iterator Oscl_Rb_Tree< Key, Value, KeyOfValue, Compare, Alloc >::begin | ( |  | ) | const`[inline]`

template<class Key, class Value, class KeyOfValue, class Compare, class Alloc>
iterator Oscl_Rb_Tree< Key, Value, KeyOfValue, Compare, Alloc >::begin | ( |  | ) | `[inline]`

template<class Key, class Value, class KeyOfValue, class Compare, class Alloc>
void Oscl_Rb_Tree< Key, Value, KeyOfValue, Compare, Alloc >::clear | ( |  | ) | `[inline]`

template<class Key, class Value, class KeyOfValue, class Compare, class Alloc>
size_type Oscl_Rb_Tree< Key, Value, KeyOfValue, Compare, Alloc >::count | ( | const Key & | k | ) | const`[inline]`

template<class Key, class Value, class KeyOfValue, class Compare, class Alloc>
bool Oscl_Rb_Tree< Key, Value, KeyOfValue, Compare, Alloc >::empty | ( |  | ) | const`[inline]`

template<class Key, class Value, class KeyOfValue, class Compare, class Alloc>
const_iterator Oscl_Rb_Tree< Key, Value, KeyOfValue, Compare, Alloc >::end | ( |  | ) | const`[inline]`

template<class Key, class Value, class KeyOfValue, class Compare, class Alloc>
iterator Oscl_Rb_Tree< Key, Value, KeyOfValue, Compare, Alloc >::end | ( |  | ) | `[inline]`

template<class Key, class Value, class KeyOfValue, class Compare, class Alloc>
Oscl_Pair<const_iterator, const_iterator> Oscl_Rb_Tree< Key, Value, KeyOfValue, Compare, Alloc >::equal_range | ( | const Key & | k | ) | const`[inline]`

template<class Key, class Value, class KeyOfValue, class Compare, class Alloc>
Oscl_Pair<iterator, iterator> Oscl_Rb_Tree< Key, Value, KeyOfValue, Compare, Alloc >::equal_range | ( | const Key & | k | ) | `[inline]`

template<class Key, class Value, class KeyOfValue, class Compare, class Alloc>
void Oscl_Rb_Tree< Key, Value, KeyOfValue, Compare, Alloc >::erase | ( | const key_type * | first,
|  | const key_type * | last
| ) | `[inline]`

template<class Key, class Value, class KeyOfValue, class Compare, class Alloc>
void Oscl_Rb_Tree< Key, Value, KeyOfValue, Compare, Alloc >::erase | ( | iterator | first,
|  | iterator | last
| ) | `[inline]`

template<class Key, class Value, class KeyOfValue, class Compare, class Alloc>
size_type Oscl_Rb_Tree< Key, Value, KeyOfValue, Compare, Alloc >::erase | ( | const key_type & | x | ) | `[inline]`

template<class Key, class Value, class KeyOfValue, class Compare, class Alloc>
void Oscl_Rb_Tree< Key, Value, KeyOfValue, Compare, Alloc >::erase | ( | iterator | position | ) | `[inline]`

template<class Key, class Value, class KeyOfValue, class Compare, class Alloc>
const_iterator Oscl_Rb_Tree< Key, Value, KeyOfValue, Compare, Alloc >::find | ( | const Key & | k | ) | const`[inline]`

template<class Key, class Value, class KeyOfValue, class Compare, class Alloc>
iterator Oscl_Rb_Tree< Key, Value, KeyOfValue, Compare, Alloc >::find | ( | const Key & | k | ) | `[inline]`

template<class Key, class Value, class KeyOfValue, class Compare, class Alloc>
void Oscl_Rb_Tree< Key, Value, KeyOfValue, Compare, Alloc >::insert_unique | ( | const value_type * | first,
|  | const value_type * | last
| ) | `[inline]`

template<class Key, class Value, class KeyOfValue, class Compare, class Alloc>
void Oscl_Rb_Tree< Key, Value, KeyOfValue, Compare, Alloc >::insert_unique | ( | const_iterator | first,
|  | const_iterator | last
| ) | `[inline]`

template<class Key, class Value, class KeyOfValue, class Compare, class Alloc>
iterator Oscl_Rb_Tree< Key, Value, KeyOfValue, Compare, Alloc >::insert_unique | ( | iterator | position,
|  | const value_type & | v
| ) | `[inline]`

template<class Key, class Value, class KeyOfValue, class Compare, class Alloc>
Oscl_Pair<iterator, bool> Oscl_Rb_Tree< Key, Value, KeyOfValue, Compare, Alloc >::insert_unique | ( | const value_type & | v | ) | `[inline]`

template<class Key, class Value, class KeyOfValue, class Compare, class Alloc>
const_iterator Oscl_Rb_Tree< Key, Value, KeyOfValue, Compare, Alloc >::lower_bound | ( | const Key & | k | ) | const`[inline]`

template<class Key, class Value, class KeyOfValue, class Compare, class Alloc>
iterator Oscl_Rb_Tree< Key, Value, KeyOfValue, Compare, Alloc >::lower_bound | ( | const Key & | k | ) | `[inline]`

template<class Key, class Value, class KeyOfValue, class Compare, class Alloc>
size_type Oscl_Rb_Tree< Key, Value, KeyOfValue, Compare, Alloc >::max_size | ( |  | ) | const`[inline]`

template<class Key, class Value, class KeyOfValue, class Compare, class Alloc>
Oscl_Rb_Tree<Key, Value, KeyOfValue, Compare, Alloc>& Oscl_Rb_Tree< Key, Value, KeyOfValue, Compare, Alloc >::operator= | ( | const Oscl_Rb_Tree< Key, Value, KeyOfValue, Compare, Alloc > & | x | ) | `[inline]`

template<class Key, class Value, class KeyOfValue, class Compare, class Alloc>
size_type Oscl_Rb_Tree< Key, Value, KeyOfValue, Compare, Alloc >::size | ( |  | ) | const`[inline]`

template<class Key, class Value, class KeyOfValue, class Compare, class Alloc>
const_iterator Oscl_Rb_Tree< Key, Value, KeyOfValue, Compare, Alloc >::upper_bound | ( | const Key & | k | ) | const`[inline]`

template<class Key, class Value, class KeyOfValue, class Compare, class Alloc>
iterator Oscl_Rb_Tree< Key, Value, KeyOfValue, Compare, Alloc >::upper_bound | ( | const Key & | k | ) | `[inline]`

The documentation for this class was generated from the following file:

- oscl_tree.h